"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _nodeContentRenderer = _interopRequireDefault(require("./node-content-renderer"));

var _treeNodeRenderer = _interopRequireDefault(require("./tree-node-renderer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Can override the following:
//
// style: PropTypes.shape({}),
// innerStyle: PropTypes.shape({}),
// reactVirtualizedListProps: PropTypes.shape({}),
// scaffoldBlockPxWidth: PropTypes.number,
// slideRegionSize: PropTypes.number,
// rowHeight: PropTypes.oneOfType([PropTypes.number, PropTypes.func]),
// treeNodeRenderer: PropTypes.func,
// nodeContentRenderer: PropTypes.func,
// placeholderRenderer: PropTypes.func,
var FileExplorerTheme = {
  nodeContentRenderer: _nodeContentRenderer.default,
  treeNodeRenderer: _treeNodeRenderer.default,
  scaffoldBlockPxWidth: 25,
  rowHeight: 25,
  slideRegionSize: 50
};
var _default = FileExplorerTheme;
exports.default = _default;