"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReactSortableTree = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _SortableTree = _interopRequireWildcard(require("./SortableTree"));

var _index = _interopRequireDefault(require("./FileExplorerTheme/index"));

var _excluded = ["onClick", "value", "expanded"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * 
 * @param { isOver, canDrop } props 
 * @returns 
 */
var PlaceholderRendererDefault = function PlaceholderRendererDefault() {
  return /*#__PURE__*/_react.default.createElement("div", {
    style: {
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center'
    }
  }, "No data found");
};
/**
* 
* @param {node, path, treeIndex, lowerSiblingCounts, isSearchMatch, isSearchFocus} rowInfo 
* @returns func or bool
*/


var canDrag = function canDrag(_ref) {
  var node = _ref.node;
  return !node.dragDisabled;
};
/**
* 
* @param {node, prevPath, prevParent, prevTreeIndex, nextPath, nextParent, nextTreeIndex} rowInfo 
* @returns func
*/


var canDrop = function canDrop(_ref2) {
  var nextParent = _ref2.nextParent;
  return !nextParent || !nextParent.dropDisabled;
};
/**
* 
* @param {treeData, node, nextParentNode, prevPath, prevTreeIndex, path, treeIndex} rowInfo 
* @returns void
*/


var onMoveNode = function onMoveNode() {};
/**
* 
* @param {treeData, node, expanded, path} rowInfo 
* @returns void
*/


var onVisibilityToggle = function onVisibilityToggle() {};

var ReactSortableTree = /*#__PURE__*/function (_Component) {
  _inherits(ReactSortableTree, _Component);

  var _super = _createSuper(ReactSortableTree);

  function ReactSortableTree() {
    var _this;

    _classCallCheck(this, ReactSortableTree);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "updateTreeData", function (treeData) {
      var onChange = _this.props.onChange;
      onChange(treeData);
    });

    _defineProperty(_assertThisInitialized(_this), "onClickNode", function (rowInfo) {
      var onClick = _this.props.onClick;

      if (typeof onClick === 'function') {
        onClick(_objectSpread(_objectSpread({}, rowInfo), {}, {
          id: rowInfo.node.id
        }));
      }
    });

    _defineProperty(_assertThisInitialized(_this), "generateNodeProps", function (rowInfo) {
      var _this$props = _this.props,
          value = _this$props.value,
          generateNodeProps = _this$props.generateNodeProps;
      var props = typeof generateNodeProps === 'function' ? generateNodeProps(rowInfo) : {};
      var selected = rowInfo.node.id === value;
      return _objectSpread({
        onClickNode: function onClickNode() {
          _this.onClickNode(rowInfo);
        },
        selected: selected
      }, props);
    });

    return _this;
  }

  _createClass(ReactSortableTree, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.expanded !== prevProps.expanded) {
        this.updateTreeData((0, _SortableTree.toggleExpandedForAll)({
          treeData: this.props.treeData,
          expanded: this.props.expanded
        }));
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          onClick = _this$props2.onClick,
          value = _this$props2.value,
          expanded = _this$props2.expanded,
          props = _objectWithoutProperties(_this$props2, _excluded);

      return /*#__PURE__*/_react.default.createElement(_SortableTree.default, _extends({}, props, {
        onChange: this.updateTreeData,
        generateNodeProps: this.generateNodeProps
      }));
    }
  }]);

  return ReactSortableTree;
}(_react.Component);

exports.ReactSortableTree = ReactSortableTree;
ReactSortableTree.defaultProps = {
  style: undefined,
  innerStyle: {
    outline: 'none'
  },
  theme: _index.default,
  expanded: null,
  searchQuery: '',
  searchFocusOffset: undefined,
  value: '',
  maxDepth: undefined,
  rowHeight: 30,
  scaffoldBlockPxWidth: 28,
  placeholderRenderer: PlaceholderRendererDefault,
  className: undefined,
  treeData: [],
  onChange: undefined,
  onClick: undefined,
  searchFinishCallback: undefined,
  generateNodeProps: null,
  onMoveNode: onMoveNode,
  onVisibilityToggle: onVisibilityToggle,
  canDrag: canDrag,
  canDrop: canDrop
};
ReactSortableTree.propTypes = {
  style: _propTypes.default.instanceOf(Object),
  innerStyle: _propTypes.default.instanceOf(Object),
  theme: _propTypes.default.instanceOf(Object),
  expanded: _propTypes.default.bool,
  searchQuery: _propTypes.default.string,
  searchFocusOffset: _propTypes.default.number,
  value: _propTypes.default.string,
  maxDepth: _propTypes.default.number,
  rowHeight: _propTypes.default.number,
  scaffoldBlockPxWidth: _propTypes.default.number,
  placeholderRenderer: _propTypes.default.any,
  className: _propTypes.default.string,
  treeData: _propTypes.default.arrayOf(Object),
  onChange: _propTypes.default.func,
  onClick: _propTypes.default.func,
  searchFinishCallback: _propTypes.default.func,
  generateNodeProps: _propTypes.default.func,
  onMoveNode: _propTypes.default.func,
  onVisibilityToggle: _propTypes.default.func,
  canDrag: _propTypes.default.func,
  canDrop: _propTypes.default.func
};
var _default = ReactSortableTree;
exports.default = _default;