"use strict";

var _treeDataUtils = require("./tree-data-utils");

var _memoizedTreeDataUtils = require("./memoized-tree-data-utils");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

describe('insertNode', function () {
  it('should handle empty data', function () {
    var params = {
      treeData: [],
      depth: 0,
      minimumTreeIndex: 0,
      newNode: {},
      getNodeKey: function getNodeKey(_ref) {
        var treeIndex = _ref.treeIndex;
        return treeIndex;
      }
    };
    var firstCall = (0, _treeDataUtils.insertNode)(params);
    var secondCall = (0, _treeDataUtils.insertNode)(params);
    expect(firstCall === secondCall).toEqual(false);
    firstCall = (0, _memoizedTreeDataUtils.memoizedInsertNode)(params);
    secondCall = (0, _memoizedTreeDataUtils.memoizedInsertNode)(params);
    expect(firstCall === secondCall).toEqual(true);
    expect((0, _memoizedTreeDataUtils.memoizedInsertNode)(params) === (0, _memoizedTreeDataUtils.memoizedInsertNode)(_objectSpread(_objectSpread({}, params), {}, {
      treeData: [{}]
    }))).toEqual(false);
  });
});